<?php

/**
 * ingreso_contratista actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage ingreso_contratista
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ingreso_contratistaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_CONTRATISTA_V',
        'RVC_TIPO_REGIMEN',
        'CIUDAD',
        'TIPO_DOCUMENTO',
        'TS_BN',
        'TS_TC'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RVC_TIPO_REGIMEN,LEFT' =>
        array(
            'id_tipo_regimen' => 'RVC_CONTRATISTA_V'
        ),
        'CIUDAD,LEFT' =>
        array(
            'id_ciudad-id' => 'RVC_CONTRATISTA_V'
        ),
        'TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_doc' => 'RVC_CONTRATISTA_V'
        ),
        'TS_BN,LEFT' =>
        array(
            'id_bn' => 'RVC_CONTRATISTA_V'
        ),
        'TS_TC,LEFT' =>
        array(
            'tipo_cuenta-id' => 'RVC_CONTRATISTA_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_CONTRATISTA_V' =>
        array(
            'id_contratista' => 'id_contratista',
            'tipo_recurso' => 'tipo_recurso',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'razon_social' => 'razon_social',
            'correo' => 'correo',
            'id_ciudad' => 'id_ciudad',
            'estado' => 'estado',
            'id_tipo_regimen' => 'id_tipo_regimen',
            'mas_empleados' => 'mas_empleados',
            'declarante_renta' => 'declarante_renta',
            'pensionado' => 'pensionado',
            'embargo' => 'embargo',
            'valor_embargo' => 'valor_embargo',
            'dependiente' => 'dependiente',
            'num_doc,||, - ,||,razon_social' => 'completo',
            'adjunto_pensionado' => 'adjunto_pensionado',
            'rut' => 'rut',
            'adjunto_rut' => 'adjunto_rut',
            'id_fondo_salud' => 'id_fondo_salud',
            'id_fondo_pension' => 'id_fondo_pension',
            'id_caja_comp' => 'id_caja_comp',
            'id_fondo_arl' => 'id_fondo_arl',
            'id_tipo_riesgo' => 'id_tipo_riesgo',
            'adjunto_arl' => 'adjunto_arl',
            'fecha_afilia_arl' => 'fecha_afilia_arl',
            'id_bn' => 'id_bn',
            'tipo_cuenta' => 'tipo_cuenta',
            'num_cuenta' => 'num_cuenta',
            'adjunto_certif_bancaria' => 'adjunto_certif_bancaria',
            'adjunto_aprobacion_supervisor' => 'adjunto_aprobacion_supervisor',
            'codigo_fondo_salud' => 'codigo_fondo_salud',
            'razon_social_fondo_salud' => 'razon_social_fondo_salud',
            'codigo_fondo_pension' => 'codigo_fondo_pension',
            'razon_social_fondo_pension' => 'razon_social_fondo_pension',
            'codigo_caja_comp' => 'codigo_caja_comp',
            'razon_social_caja_comp' => 'razon_social_caja_comp',
            'codigo_fondo_arl' => 'codigo_fondo_arl',
            'razon_social_fondo_arl' => 'razon_social_fondo_arl',
            'aplica_balance_contrato' => 'aplica_balance_contrato',
            'id_tip_ter' => 'id_tip_ter',
            'descripcion_tertip' => 'descripcion_tertip',
            'numero_rut' => 'numero_rut',
            'id_pais' => 'id_pais',
            'pais' => 'pais',
            'id_depto' => 'id_depto',
            'coddepto' => 'coddepto',
            'departamento' => 'departamento',
            'codmun' => 'codmun',
            'municipio' => 'municipio',
            'direccion' => 'direccion',
            'telefono' => 'telefono',
            'correo_alternativo' => 'correo_alternativo',
            'actividad_principal' => 'actividad_principal',
            'fecha_act_principal' => 'fecha_act_principal',
            'actividad_secundaria' => 'actividad_secundaria',
            'fecha_act_secundaria' => 'fecha_act_secundaria',
            'otra_actividad_una' => 'otra_actividad_una',
            'otra_actividad_dos' => 'otra_actividad_dos',
            'ocupacion' => 'ocupacion',
            'num_establecimientos' => 'num_establecimientos',
            'pnombre' => 'pnombre',
            'snombre' => 'snombre',
            'papellido' => 'papellido',
            'sapellido' => 'sapellido',
            'tarifa_caja_comp' => 'tarifa_caja_comp',
            'adjunto_caja_comp' => 'adjunto_caja_comp',
            'adjunto_fondo_salud' => 'adjunto_fondo_salud',
            'adjunto_fondo_pension' => 'adjunto_fondo_pension',
            'profesion' => 'profesion',
            'fecha_afilia_salud' => 'fecha_afilia_salud',
            'fecha_afilia_pension' => 'fecha_afilia_pension',
            'id_actividad_ciiu' => 'id_actividad_ciiu',
            'id_dian_actividad' => 'id_dian_actividad'
        ),
        'RVC_TIPO_REGIMEN' =>
        array(
            'descripcion' => 'tipo_regimen',
            'aplica_iva' => 'aplica_iva'
        ),
        'CIUDAD' =>
        array(
            'nombre' => 'nombre_ciudad',
            'tarifa_ica' => 'tarifa_ica_ciudad',
            'base_deveg' => 'base_deveg',
            'base_deduc' => 'base_deduc'
        ),
        'TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'tipo_documento',
            'abreviacion' => 'abreviacion_td',
            'codigo_siif' => 'codigo_siif'
        ),
        'TS_BN' =>
        array(
            'codigo' => 'codigo_bn',
            'descripcion' => 'descripcion_bn',
            'estado' => 'estado_bn',
            'abreviatura' => 'abreviatura_bn',
            'codigo_ach' => 'codigo_ach_bn',
            'codigo,||, - ,||,descripcion' => 'completo_bn',
        ),
        'TS_TC' =>
        array(
            'descripcion' => 'descripcion_tc'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_CONTRATISTA_V' => array(
            'id_contratista,a' => array('!=' => array(-1)),
            'id_contratista,b' => array('=' => array('id_contratista')),
            'tipo_recurso' => array('=' => array('tipo_recurso')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'id_tipo_regimen' => array('=' => array('id_tipo_regimen')),
            'id_ciudad' => array('=' => array('id_ciudad')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'RVC_CONTRATISTA_V' =>
        array(
            'num_doc' => array('LIKE' => array('input', '%')),
            'razon_social' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'tipo_recurso', 'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contratista'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_contratista'); //llave primaria
    protected $field_names = array('tipo_recurso', 'id_tipo_doc', 'num_doc', 'razon_social',
        'correo', 'id_ciudad', 'estado',
        'id_tipo_regimen', 'mas_empleados', 'declarante_renta', 'pensionado', 'embargo',
        'valor_embargo', 'dependiente', 'aplica_balance_contrato', 'pnombre', 'snombre', 'papellido', 'sapellido'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_CONTRATISTA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contratista'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();
        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        $num_doc = $request['num_doc'];
        $correo = $request['correo'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
SELECT *
FROM rvc_contratista
where
num_doc = $num_doc
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "el documento ($num_doc) ya esta registrado para un contratista.";
            $errors['servicio'] = "Registro Contratista";
        }

        //VALIDAR CORREO
        $sql = <<<EOD
SELECT validar_dominio_correo, DOMINIO_CORREO_VALIDO
FROM rvc_param_gen
where
id = 1
EOD;
        $records = CN_TABLE::executeSQL($sql);
        $logger->info("validar_correo:" . $records[0]['validar_dominio_correo']);

        if ($records[0]['validar_dominio_correo'] == 1) {
            $dominio = explode('@', $correo);
            $correct_domain = $records[0]['dominio_correo_valido'];
            $logger->info("Dominio correo:" . $dominio[1]);
            $logger->info("Dominio valido:" . $records[0]['dominio_correo_valido']);
            if ($dominio[1] != $correct_domain) {
                $errors['mensaje'] = "Dominio de correo invalido, tiene que colocar un correo($correct_domain).";
                $errors['servicio'] = "Registro Contratista";
            }
        }



        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;
        $logger = sfContext::getInstance()->getLogger();

        /*
         * Variables request
         */
        $correo = $request['correo'];
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        //VALIDAR CORREO
        $sql = <<<EOD
SELECT validar_dominio_correo, DOMINIO_CORREO_VALIDO
FROM rvc_param_gen
where
id = 1
EOD;
        $records = CN_TABLE::executeSQL($sql);
        $logger->info("validar_correo:" . $records[0]['validar_dominio_correo']);

        if ($records[0]['validar_dominio_correo'] == 1) {
            $dominio = explode('@', $correo);
            $correct_domain = $records[0]['dominio_correo_valido'];
            $logger->info("Dominio correo:" . $dominio[1]);
            $logger->info("Dominio valido:" . $records[0]['dominio_correo_valido']);
            if ($dominio[1] != $correct_domain) {
                $errors['mensaje'] = "Dominio de correo invalido, tiene que colocar un correo($correct_domain).";
                $errors['servicio'] = "Registro Contratista";
            }
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['razon_social'] = $request['pnombre'] . " " . $request['snombre'] . " " . $request['papellido'] . " " . $request['sapellido'];
            $request['tipo_recurso'] = 2;
        }

        //accion update
        if ($Action == "UPDATE") {
            $request['razon_social'] = $request['pnombre'] . " " . $request['snombre'] . " " . $request['papellido'] . " " . $request['sapellido'];
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        $nitocc = $list_data_post[0]['num_doc'];

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */

        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }



            $int++;
        }

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            try {

                $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                $this->conn->beginTransaction();



                /**
                 * Se valida si existe el tercero no se borra, ni se crea - 20200326 LAVILA
                 */
                $sql = <<<EOD
select * FROM TERCEROS WHERE 1=1 AND NITOCC = '$nitocc'                              
EOD;
                $ter = CN_TABLE::executeSQL($sql);

                if (count($ter) == 0) {
                    if ($entidadCliente == 1 || $entidadCliente == 2) {
                        $sql = <<<EOD
INSERT INTO TERCEROS
(
  NITOCC,
  TIPTER,
  RAZSOC,
  CIUDAD,
  TELEFO,
  TELFAX,
  DIRECC,
  ESTADO,
  EMAIL,
  SUELDO,
  CARGO,
  CODREG,
  ID_TIPO_TRABA_CONTRA,
  FECHA_ACT,
  CARGO_TEXTO
)
SELECT tab0.num_doc AS nitocc,
       NVL(tab0.id_tip_ter,1) AS tipter,
       tab0.razon_social AS razsoc,
       tab2.nombre AS ciudad,
       NVL(tab0.telefono,'') AS telefo,
       NVL(tab0.telefono,'') AS telfax,
       NVL(tab0.direccion,'') AS direcc,
       tab0.estado AS estado,
       NVL(tab0.correo,'') AS email,
       NVL(tab3.valor_mensualizado,0) AS sueldo,
       '' AS cargo,
       '' AS codreg,
       3 AS id_tipo_traba_contra,
       SYSDATE AS fecha_act,
       '' AS cargo_texto
FROM RVC_CONTRATISTA tab0
  LEFT JOIN TERCEROS tab1 ON tab0.num_doc = tab1.nitocc
  LEFT JOIN CIUDAD tab2 ON tab0.id_ciudad = tab2.id
  LEFT JOIN (SELECT tab4.*
             FROM (SELECT aut.*,
                          ROW_NUMBER() OVER (PARTITION BY aut.id_contratista ORDER BY aut.fecha_contrato DESC) AS rn
                   FROM RVC_CONTRATO aut) tab4
             WHERE 1 = 1
             AND   tab4.rn = 1) tab3 ON tab3.id_contratista = tab0.id_contratista
WHERE 1 = 1
AND   tab1.nitocc IS NULL    
EOD;

                        $this->conn->execute($sql);
                    }
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
                $logger->info("COMMIT DE TODAS LAS TRANSACCIONES");
            } catch (Exception $ex) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
                $logger->info("ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR");
            }
        }

        //accion update
        if ($Action == "UPDATE") {


            try {

                $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                $this->conn->beginTransaction();


                /**
                 * Se valida si existe el tercero no se borra, ni se crea - 20200326 LAVILA
                 */
                $sql = <<<EOD
select * FROM TERCEROS WHERE 1=1 AND NITOCC = '$nitocc'                              
EOD;
                $ter = CN_TABLE::executeSQL($sql);

                if (count($ter) > 0) {
                    $id_contratista = $list_data_post[0]['id_contratista'];

                    if ($entidadCliente == 1 || $entidadCliente == 2 || $entidadCliente == 7) {
                        $sql = <<<EOD
                               
    SELECT tab0.num_doc AS nitocc,
       NVL(tab0.id_tip_ter,1) AS tipter,
       tab0.razon_social AS razsoc,
       tab2.nombre AS ciudad,
       NVL(tab0.telefono,'') AS telefo,
       NVL(tab0.telefono,'') AS telfax,
       NVL(tab0.direccion,'') AS direcc,
       tab0.estado AS estado,
       NVL(tab0.correo,'') AS email,
       NVL(tab3.valor_mensualizado,0) AS sueldo,
       '' AS cargo,
       '' AS codreg,
       3 AS id_tipo_traba_contra,
       to_char(SYSDATE,'yyyy-mm-dd') AS fecha_act,
       '' AS cargo_texto
FROM RVC_CONTRATISTA tab0
  LEFT JOIN CIUDAD tab2 ON tab0.id_ciudad = tab2.id
  LEFT JOIN (SELECT tab4.*
             FROM (SELECT aut.*,
                          ROW_NUMBER() OVER (PARTITION BY aut.id_contratista ORDER BY aut.fecha_contrato DESC) AS rn
                   FROM RVC_CONTRATO aut) tab4
             WHERE 1 = 1
             AND   tab4.rn = 1) tab3 ON tab3.id_contratista = tab0.id_contratista
WHERE 1 = 1      AND tab0.id_contratista=$id_contratista                     
EOD;


                        $contratista = CN_TABLE::executeSQL($sql);
                        $tipter = $contratista[0]['tipter'];
                        $razon_soc = $contratista[0]['razsoc'];
                        $ciudad = $contratista[0]['ciudad'];
                        $telefono = $contratista[0]['telefo'];
                        $telfax = $contratista[0]['telfax'];
                        $direc = $contratista[0]['direcc'];
                        $estado = $contratista[0]['estado'];
                        $email = $contratista[0]['email'];
                        $sueldo = $contratista[0]['sueldo'];
                        $cargo = $contratista[0]['cargo'];
                        $codigo_reg = $contratista[0]['codreg'];
                        $tipo_traba_contra = $contratista[0]['id_tipo_traba_contra'];
                        $fecha_act = $contratista[0]['fecha_act'];
                        $cargo_text = $contratista[0]['cargo_texto'];

                        $sql = <<<EOD
    UPDATE TERCEROS
   SET TIPTER = lpad('$tipter',2,'0'),
       RAZSOC = '$razon_soc',
       CIUDAD = '$ciudad',
       TELEFO = '$telefono',
       TELFAX = '$telfax',
       DIRECC = '$direc',
       ESTADO = nvl('$estado',0),
       EMAIL = '$email',
       SUELDO = $sueldo,
       CARGO = '$cargo',
       CODREG = '$codigo_reg',
       ID_TIPO_TRABA_CONTRA = $tipo_traba_contra,
       FECHA_ACT = to_date('$fecha_act','yyyy-mm-dd'),
       CARGO_TEXTO = '$cargo_text'
WHERE NITOCC = '$nitocc'
EOD;



                        $this->conn->execute($sql);
                    }
                } else {


                    $sql = <<<EOD
INSERT INTO TERCEROS
(
  NITOCC,
  TIPTER,
  RAZSOC,
  CIUDAD,
  TELEFO,
  TELFAX,
  DIRECC,
  ESTADO,
  EMAIL,
  SUELDO,
  CARGO,
  CODREG,
  ID_TIPO_TRABA_CONTRA,
  FECHA_ACT,
  CARGO_TEXTO
)
SELECT tab0.num_doc AS nitocc,
       lpad(NVL(tab0.id_tip_ter,1),2,'0') AS tipter,
       tab0.razon_social AS razsoc,
       tab2.nombre AS ciudad,
       NVL(tab0.telefono,'') AS telefo,
       NVL(tab0.telefono,'') AS telfax,
       NVL(tab0.direccion,'') AS direcc,
       tab0.estado AS estado,
       NVL(tab0.correo,'') AS email,
       NVL(tab3.valor_mensualizado,0) AS sueldo,
       '' AS cargo,
       '' AS codreg,
       3 AS id_tipo_traba_contra,
       SYSDATE AS fecha_act,
       '' AS cargo_texto
FROM RVC_CONTRATISTA tab0
  LEFT JOIN TERCEROS tab1 ON tab0.num_doc = tab1.nitocc
  LEFT JOIN CIUDAD tab2 ON tab0.id_ciudad = tab2.id
  LEFT JOIN (SELECT tab4.*
             FROM (SELECT aut.*,
                          ROW_NUMBER() OVER (PARTITION BY aut.id_contratista ORDER BY aut.fecha_contrato DESC) AS rn
                   FROM RVC_CONTRATO aut) tab4
             WHERE 1 = 1
             AND   tab4.rn = 1) tab3 ON tab3.id_contratista = tab0.id_contratista
WHERE 1 = 1
AND   tab1.nitocc IS NULL    
EOD;

                    $this->conn->execute($sql);
                }

                $this->conn->commit();
                $logger->info("COMMIT DE TODAS LAS TRANSACCIONES");
            } catch (Exception $ex) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
                $logger->info("ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR");
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
